unit Main;

interface

(*
========================================
A Description rapide                   -
========================================

Cette Form cre un jeu PUISSANCE 4, avec les options suivante:
- Possibilit de jouer 1 Vs 1, 1 VS Comp ou Comp VS Comp
- A chaque coup jou, seules les nouvelles combinaisons
  gagnantes sont rvalues.
- Le Computer utilise un Algo du type MIN MAX trs basic pour jouer, mais
  le choix dfinitif du coup jou est alatoire selon une loi qui offre
  le plus de chances aux bons coups. Donc quand le computer joue, toutes
  les parties sont diffrentes.
- Possibilit de rgler la profondeur de recherche du MIN/MAX
- Lorsque la partie est termine, si les 2 joueurs sont en mode auto, alors
  la partie est relance automatiquement aprs un temps alatoire.
- Lorsque le mode est manuel,  il suffit de dplacer la souris
  au dessus de la colonne ou l'on dsire jouer puis de cliquer pour
  valider le choix. La main passe alors automatiquement  l'autre joueur.
- Un pion est affich en bas de la fentre pour chaque joueur lorsqu'il
  lui reste des pions. Ce poin est automatiquement dplac sur la colonne
  pointe par la souris, quand on est en mode manuel.
- Affichage du nombre de pions restant pour chaque joueur.
- Comptabilisation du temps de rflexion de chaque joueur (semble buggu
  quand Mr Computer joue.
- Comptabilisation du %age de victoire de chaque joueur et du nombre de
  parties nulles.
- Petit skin  la fin de la partie avec un texte en overlay sur la table
  de jeu.
- Informations sur l'tat du jeu dans la barre de status.
- Enfin, les pions sont marqus "MB" pour faire honneur  l'original.

========================================
B Amliorations possibles:             -
========================================
- Optimiser le jeu du computer (cf "TODO" dans la suite)
- Faire tourner les icones joues, mais malheureusement, il
  n'existe aucun outil qui fait a dans les libs de Base de DELPHI
  SNIFF.

========================================
C Auteur:                              -
========================================
- Par Masterglob, le 20/01/2007
- contact: masterglob@gmail.com

*)

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ImgList, StdCtrls, Gauges, ComCtrls, Menus,Math, Spin;

(*
========================================
- Caractristiques gnrales           -
========================================
*)
// Deux joueurs:
Const NO_PLAYER = -1;
Const Player1   = 0;
Const Player2   = Player1+1;

// Jetons, taille du jeu etc...
const FST_ROW = 0;
const LST_ROW = 6;
const FST_LINE = 0;
const LST_LINE = 5;

// Tableau refltant l'tat du jeu[Colonne,ligne]
// ROW=0 ==> gauche
// LINE=0 ==> Haut (... bizarre peut etre mais plus simple  grer)

Type  TCoinsPlayed= Array[FST_ROW..LST_ROW,FST_LINE..LST_LINE] of shortint;

Const NB_JETONS_TOTAL = (LST_ROW-FST_ROW+1)*(LST_LINE-FST_LINE+1) ;
Const NB_JETONS_PAR_JOUEUR = (NB_JETONS_TOTAL) div 2 ;

const ICON_SIZE = 40 ;
const ROW_SIZE = 45 ;
const FST_ROW_POS  = 135;

// Couleur pour chaque joueur
const PlayerColor:array[Player1..Player2] of TColor = (clblue,clYellow);

(*
========================================
- Informations sur le jeu              -
========================================
*)
// TGameInfos: informations sur le jeu
type TGameInfos= record
  CoinsLeft:array[Player1..Player2] of integer;
  Victory:array[Player1..Player2] of integer;
  Time:array[Player1..Player2] of integer;
  CoinPos:array[Player1..Player2] of integer;
  CoinsPlayed:TCoinsPlayed;  // Tableau refltant l'tat du jeu
  DrawGame : integer;
  Playing : integer;  // active player
  nbGamesPlayed:integer;
  end;

// TGameObjects : objets pour chaque joueur
type TGameObjects= record
  LblName : TLabel;
  LblCoinsLeft : TLabel;
  ImageCoinsLeft:TImage;
  RadioAuto:TRadioButton;
  LabTime:TLabel;
  end;

//TGameSate : tat du jeu
type TGameSate = (gsNotStarted, gsPlaying, gsAutoPlaying, gsFinished);


(*
========================================
- classe TForm1                        -
========================================
*)

type
  TForm1 = class(TForm)
    LabPlayer1: TLabel;
    LabPlayer2: TLabel;
    PanelPl1: TPanel;
    PanlePl2: TPanel;
    LabelNbJetonsPl1: TLabel;
    LabelNbJetonsPl2: TLabel;
    BtStart: TButton;
    GaugeStats: TGauge;
    Image1: TImage;
    Image2: TImage;
    StatusBar1: TStatusBar;
    LblVictoryRate: TLabel;
    ImgPl1Coin: TImage;
    ImgPl2Coin: TImage;
    Panel1: TPanel;
    ImgTable: TImage;
    RadioButton1: TRadioButton;
    RBPlayer1Auto: TRadioButton;
    RadioButton3: TRadioButton;
    RBPlayer2Auto: TRadioButton;
    Timer1: TTimer;
    LevelAutoPl1: TSpinButton;
    LevelAutoPl2: TSpinButton;
    LabTimePl1: TLabel;
    LabTimePl2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BtStartClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImgPl1CoinMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure LevelAutoPl1DownClick(Sender: TObject);
    procedure LevelAutoPl1UpClick(Sender: TObject);
    procedure LevelAutoPl2DownClick(Sender: TObject);
    procedure LevelAutoPl2UpClick(Sender: TObject);
  private
    GameState: TGameSate;
    GameInfos:TGameInfos;
    GameObjects:Array[Player1..Player2] of TGameObjects;
    PlayerCoin:Array[NO_PLAYER..Player2] of TBitmap;
    ImgPlayerCoin:Array [NO_PLAYER..Player2] of TImage;
    Table:TBitmap;
    WonGameBitmap:Array [NO_PLAYER..Player2] of TBitmap;

    //====================================================
    // Procedures liees au jeu
    procedure InitGame;
    procedure StartGame;

    // Action: le joueur courant a jou dans cette colonne
    procedure PlayedInRow(Row:integer);

    // Positionnement d'un jeton dans la colonne
    function PlayCoin(Player:integer;Row: integer;var CoinsPlayed: TCoinsPlayed):integer;

    // renvoie true si la col est pleine
    function  IsRowFull(Row:integer):boolean;

    // Indique si le joueur a gagn en jouant  cette position
    function  PlayerHasWon(Player:integer;Row,Line:integer;CoinsPlayed:TCoinsPlayed):boolean;

    // Fait jouer l'ordinateur tout seul
    procedure  ComputerPlays();

    //====================================================
    // procedure d'affichage
    procedure RefreshDrawing;
    procedure DrawTable(var Bitmap:TBitmap);
    procedure DrawCoins;

    procedure GameComment(Comment:String);
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;


implementation

{$R *.DFM}

(*
   Diverses routines utiliss pour l'affichage. Hors Classe
*)
// Merci google pour afficher une image incline!
procedure SetCanvasFont(Bm:TBitmap; s:string;col:TColor);
var
lf: TLogFont;
tf: TFont;
h:integer;
begin
  with Bm.Canvas do
  begin
    Font.Height := 60;
    Font.Height := (84 *  (Bm.Height-20)) div TextWidth(s);
    Font.Name:='Arial';
    Font.style:=[fsBold];
    Font.Color:=col;

    h:=TextHeight(s);
    tf := TFont.Create;
    tf.Assign(Font);
    GetObject(tf.Handle, SizeOf(lf), @lf);
    lf.lfEscapement := Bm.Height+70;
    lf.lfOrientation := Bm.Height+70;
    lf.lfQuality:=200;
    tf.Handle := CreateFontIndirect(lf);
    SelectObject(Handle, CreateFontIndirect(lf));
    TextOut(0, Bm.Height-h, s);

    Font.Assign(tf);
    tf.Free;
  end;
end;



{ TForm1 }

(*
======================================
- Cration/ destruction des objets   -
======================================
*)

procedure TForm1.FormCreate(Sender: TObject);
var Player:integer;
begin
  // Initialisation des objets pour chaque joueur
  // mise a jour de GameObjects
  GameObjects[Player1].LblName:=LabPlayer1;
  GameObjects[Player2].LblName:=LabPlayer2;
  GameObjects[Player1].LblCoinsLeft:=LabelNbJetonsPl1;
  GameObjects[Player2].LblCoinsLeft:=LabelNbJetonsPl2;
  GameObjects[Player1].ImageCoinsLeft:=Image1;
  GameObjects[Player2].ImageCoinsLeft:=Image2;
  GameObjects[Player1].RadioAuto := RBPlayer1Auto;
  GameObjects[Player2].RadioAuto := RBPlayer2Auto;
  RBPlayer2Auto.Tag:=5;
  RBPlayer1Auto.Tag:=5;
  RBPlayer1Auto.Caption:='Auto('+IntToStr(RBPlayer1Auto.Tag)+')';
  RBPlayer2Auto.Caption:='Auto('+IntToStr(RBPlayer2Auto.Tag)+')';
  GameObjects[Player1].LabTime:=LabTimePl1;
  GameObjects[Player2].LabTime:=LabTimePl2;

  // Cration d'un panel dans la statusbar
  StatusBar1.Panels.Add();

  // Chargement des bitmaps dans le fichier .res                                              
  for Player:= NO_PLAYER to Player2 do
  begin
    PlayerCoin[Player]:=TBitmap.Create;
    PlayerCoin[Player].Width:=40;
    PlayerCoin[Player].Height:=40;
    PlayerCoin[Player].Transparent := True;
    PlayerCoin[Player].Transparentmode := tmAuto;
  end;
  PlayerCoin[Player1].LoadFromResourceName(hInstance,'BLUECoin');
  PlayerCoin[Player1].TransparentColor := PlayerCoin[Player1].Canvas.Pixels[1,1];
  PlayerCoin[Player2].LoadFromResourceName(hInstance,'YellowCoin');
  PlayerCoin[Player2].TransparentColor := PlayerCoin[Player2].Canvas.Pixels[1,1];
  PlayerCoin[NO_PLAYER].LoadFromResourceName(hInstance,'EMPTYCOIN');
  PlayerCoin[NO_PLAYER].Transparent := false;

  // Affectation des bitmap:
  ImgPl1Coin.Canvas.Draw(0,0,PlayerCoin[Player1]);
  ImgPl2Coin.Canvas.Draw(0,0,PlayerCoin[Player2]);

  ImgPlayerCoin[Player1]:=ImgPl1Coin;
  ImgPlayerCoin[Player2]:=ImgPl2Coin;

  // Dessin de la table dans un bitmap
  Table:=TBitmap.Create();
  Table.Width:=ImgTable.Width;
  Table.Height:=ImgTable.Height;
  DrawTable(Table);

  // Dessin du bitmap pour le match nul
  WonGameBitmap[NO_PLAYER]:=TBitmap.Create();
  WonGameBitmap[NO_PLAYER].Width:=ImgTable.Width;
  WonGameBitmap[NO_PLAYER].Height:=ImgTable.Height;
  SetCanvasFont(WonGameBitmap[NO_PLAYER],'!Partie nulle!',rgb(200,100,110));
  WonGameBitmap[NO_PLAYER].TransparentColor:=clwhite;
  WonGameBitmap[NO_PLAYER].TransparentMode:=tmAuto;
  WonGameBitmap[NO_PLAYER].Transparent:=true;

    // Dessin du bitmap pour le match gagn par joueur 1
  for Player:= Player1 to Player2 do
  begin
    WonGameBitmap[Player]:=TBitmap.Create();
    WonGameBitmap[Player].Width:=ImgTable.Width;
    WonGameBitmap[Player].Height:=ImgTable.Height;
    SetCanvasFont(WonGameBitmap[Player],
           '!Le joueur '+IntToStr(Player+1)+' gagne!',ClGreen);
    WonGameBitmap[Player].TransparentColor:=clwhite;
    WonGameBitmap[Player].TransparentMode:=tmAuto;
    WonGameBitmap[Player].Transparent:=true;
  end;

  // initialisation du jeu
  InitGame();

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  PlayerCoin[Player1].destroy;
  PlayerCoin[Player2].destroy;

  Table.destroy;
end;


procedure TForm1.FormActivate(Sender: TObject);
begin
  RefreshDrawing();
end;


(*
======================================
- Routines d'affichage               -
======================================
*)

procedure TForm1.RefreshDrawing;
var Player,nbWon:integer;
begin


  // Affichage de l'cran

  // Dsactivation du bouton en cours de partie
  BtStart.Enabled := (GameState<>gsPlaying);

  // Statistiques:
  nbWon:=GameInfos.nbGamesPlayed-GameInfos.DrawGame;
  LblVictoryRate.Caption:=format('Victoires: %d parties gagnes sur %d parties joues',
                         [nbWon,GameInfos.nbGamesPlayed]);
  GaugeStats.MinValue:=0;
  GaugeStats.MaxValue:=GameInfos.nbGamesPlayed-GameInfos.DrawGame;
  GaugeStats.Progress:=GameInfos.Victory[Player1];
  If nbWon<=0 then
  begin
    // Aucune partie joue. Stats: Grises
    GaugeStats.BackColor := clGray;
    GaugeStats.ForeColor := clGray;
    GaugeStats.ShowText:=false;
  end
  else
  begin
    // Stats actives (au moins une partie termine)
    GaugeStats.BackColor := PlayerColor[Player2];
    GaugeStats.ForeColor := PlayerColor[Player1];
    GaugeStats.ShowText:=true;
  end;

  for Player:= Player1 to Player2 do
  begin
    // Couleurs
    GameObjects[Player].LblName.Font.Color:= Playercolor[Player];
    GameObjects[Player].LblCoinsLeft.Font.Color:= Playercolor[Player];

  end;

  // Mise  jour des jetons restant pour chaque joueur
  for Player:= Player1 to Player2 do
  begin
    // Couleurs
    GameObjects[Player].LblCoinsLeft.Caption:=
      'Jetons : '+
      IntToStr(GameInfos.CoinsLeft[Player]);

    //Dessin du jeton de chaque joueur
    // reste-t-il des jetons?
    ImgPlayerCoin[Player].visible:=  GameInfos.CoinsLeft[Player]>0;

    // -1 indique que le jeton n'est pas en jeu.
    if GameInfos.CoinPos[Player] < 0 then
    begin
      ImgPlayerCoin[Player].Left:=GameObjects[Player].LblCoinsLeft.left+10;
      ImgPlayerCoin[Player].top :=280;
    end
    else
    begin
      ImgPlayerCoin[Player].Left:=GameInfos.CoinPos[Player]*ROW_SIZE+FST_ROW_POS;
      ImgPlayerCoin[Player].top :=40;
    end;
  end;

  //Dessin du jeu et des pions.
  // On affiche les pions
  DrawCoins();
  
  // On affiche la table
  ImgTable.Canvas.Draw(0,0,Table);

  // Statut de la partie: (texte overlay)
  if GameState = gsFinished then
  begin
    // Partie terminee
    ImgTable.Canvas.Draw(0,0,WonGameBitmap[GameInfos.Playing]);
  end;

end;

procedure TForm1.DrawCoins;
var Row,Line:integer;
  X1,Y1,Xc,Yc:integer;
  PlayerId:integer;
begin
  X1:=FST_ROW_POS-Panel1.left-1+ICON_SIZE div 2;
  Y1:=5+ICON_SIZE div 2;
  for Row:=FST_ROW to LST_ROW do
  begin
    Xc := X1 + Row * ROW_SIZE-ICON_SIZE div 2 ;
    for line:=FST_LINE to LST_LINE do
    begin
      // en hauteur les jetons se touchent donc ICON_SIZE = distance
      yc:=y1+line*ICON_SIZE-ICON_SIZE div 2;
      PlayerId:=GameInfos.CoinsPlayed[Row,Line];
      if (PlayerId>=NO_PLAYER) and (PlayerId<=Player2) then
      begin
        ImgTable.Canvas.Draw(xc,yc,PlayerCoin[PlayerId]);
      end
    end;
  end;
end;


procedure TForm1.DrawTable(var Bitmap: TBitmap);
var row,line:integer;
  s:string;
  X1,Y1,Xc,Yc:integer;
const  HoleRadius = 17;
       BackCol=$14141E;
       Forecol=$64705A;
      // = 34/2 , un peu plus petit que l'icone de taille reelle 36
begin
  with Bitmap.Canvas do
  begin

    // fond;
    Brush.Style:=bsSolid;
    Brush.Color:=BackCol;
    FillRect(GetClientRect);

    // Dessin des trous pour les pions (un peu plus petit que les pions
    // ont une taille de 36*36 dans un bitmap de 40*40 :centr)
    Bitmap.TransparentColor:= Forecol;
    Bitmap.TransparentMode:=tmFixed;
    Bitmap.Transparent:=true;

    Brush.Color:=Forecol;
    Pen.Color:=Forecol;
    X1:=FST_ROW_POS-Panel1.left-1+ICON_SIZE div 2;
    Y1:=5+ICON_SIZE div 2;
    for Row:=FST_ROW to LST_ROW do
    begin
      // en largeur les jetons ont un ecart de 5 pixel =  ROW_SIZE- ICON_SIZE
      Xc := X1 + Row * ROW_SIZE ;
      for line:=FST_LINE to LST_LINE do
      begin
        // en hauteur les jetons se touchent donc ICON_SIZE = distance
        yc:=y1+line*ICON_SIZE;
        Ellipse( Xc-HoleRadius,yc-HoleRadius,
                 Xc+HoleRadius,Yc+HoleRadius)
      end;
    end;

    // Petit skin pour faire nice.
    Brush.Color:=BackCol;
    Font.Size:=7;
    Font.Name:='arial';
    Font.color:=clGreen;
    s:='Puissance 4 par masterglob';
    Textout(Bitmap.Width-Textwidth(s)-2,Bitmap.Height-TextHeight('s')-1,s);

  end;
end;



procedure TForm1.GameComment(Comment: String);
begin
  StatusBar1.Panels[0].Text:=Comment;
end;

procedure TForm1.InitGame;
var Player:integer;
var row,line:integer;
begin
    Randomize;

  // Initialisation des variables
  // Etat du jeu : non commenc
  GameState:=gsNotStarted;

  // Infos du jeu
  for Player:= Player1 to Player2 do
  begin
    GameInfos.Victory[Player]:=0;
    // Les joueurs n'ont pas de jetons
    GameInfos.CoinsLeft[Player]:=0;

    GameInfos.CoinPos[Player]:=-1;

    // On rinitialise le temps de reflexion
    GameInfos.Time[Player]:=0;

  end;
  GameInfos.DrawGame:=0;
  GameInfos.nbGamesPlayed:=0;

  // On vide la table de jeu
  for Row:=FST_ROW to LST_ROW do
  begin
    for line:=FST_LINE to LST_LINE do
    begin
      GameInfos.CoinsPlayed[Row,Line]:= NO_PLAYER ;
    end;
  end;

  //
  GameComment('Partie non commence');

end;


(*
======================================
- Interaction/ Callback              -
======================================
*)


procedure TForm1.BtStartClick(Sender: TObject);
begin
  StartGame();
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var Row:integer;
begin

  // Pas de traitement si la partie est finie ou pas commence
  if GameState<>gsPlaying then exit;

  // La souris passe au dessus de la colonne?
  if (y<40) or (y>85) then
    exit;  // non: sortie
  //Verification de la colonne
  Row:= (x-FST_ROW_POS) div ROW_SIZE;
  If (Row<0) or (Row>6) then
   exit;

  if not GameObjects[GameInfos.Playing].RadioAuto.Checked then
  begin
    // En mode Auto, on ne gre pas le changement de colonne
    GameInfos.CoinPos[GameInfos.Playing]:= Row;

    // Et on dessine
    RefreshDrawing();
  end;

end;

procedure TForm1.ImgPl1CoinMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Row:integer;
begin
  if GameState<>gsPlaying then exit;
  Row:=GameInfos.CoinPos[GameInfos.Playing];
  // On n'active le clic que si la colonne n'est pas pleine
  If not IsRowFull(Row) then
    PlayedInRow(Row)
  else
    GameComment('La colonne est dj remplie, choisissez-en une autre');
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Player,t:integer;
begin

  // Lorsque les 2 joueurs sont en auto, on relance la partie arbitrairement
  if (GameState=gsFinished) and (random>0.99) then
  begin
    BtStartClick(Sender);
    exit;
  end;

  // gestion du temps de jeu
  If (GameState=gsPlaying) or (GameState=gsAutoPlaying) then
  begin
    Inc(GameInfos.Time[GameInfos.Playing]);
  end
  else exit;


  // Mise  jour de l'affichage du temps
  for Player:= Player1 to Player2 do
  begin
    //Dure de rflexion
    t:=GameInfos.Time[Player] div 10;
    GameObjects[Player].LabTime.caption:=
      Format('%2dm %2ds',[t div 60,t mod 60]);
  end;

  // gestion du mode automatique (L'ordinateur joue)
  if (GameObjects[GameInfos.Playing].RadioAuto.Checked) and
     (GameState=gsPlaying) then
  begin
    ComputerPlays;
  end;
end;

procedure TForm1.LevelAutoPl1DownClick(Sender: TObject);
begin
  if RBPlayer1Auto.Tag>0 then RBPlayer1Auto.Tag:=RBPlayer1Auto.Tag-1;
  RBPlayer1Auto.Caption:='Auto('+IntToStr(RBPlayer1Auto.Tag)+')';
  GameComment('Niveau auto joueur 1 chang  '+inttostr(RBPlayer1Auto.Tag));
end;

procedure TForm1.LevelAutoPl1UpClick(Sender: TObject);
begin
  if RBPlayer1Auto.Tag<9 then RBPlayer1Auto.Tag:=RBPlayer1Auto.Tag+1;
  RBPlayer1Auto.Caption:='Auto('+IntToStr(RBPlayer1Auto.Tag)+')';
  GameComment('Niveau auto joueur 1 chang  '+inttostr(RBPlayer1Auto.Tag));

end;

procedure TForm1.LevelAutoPl2DownClick(Sender: TObject);
begin
  if RBPlayer2Auto.Tag>0 then RBPlayer2Auto.Tag:=RBPlayer2Auto.Tag-1;
  RBPlayer2Auto.Caption:='Auto('+IntToStr(RBPlayer2Auto.Tag)+')';
  GameComment('Niveau auto joueur 2 chang  '+inttostr(RBPlayer2Auto.Tag));
end;

procedure TForm1.LevelAutoPl2UpClick(Sender: TObject);
begin
  if RBPlayer2Auto.Tag<9 then RBPlayer2Auto.Tag:=RBPlayer2Auto.Tag+1;
  RBPlayer2Auto.Caption:='Auto('+IntToStr(RBPlayer2Auto.Tag)+')';
  GameComment('Niveau auto joueur 2 chang  '+inttostr(RBPlayer2Auto.Tag));
end;

(*
======================================
- Fonctions de getion du jeu         -
======================================
*)


procedure TForm1.StartGame;
var Player:integer;
var row,line:integer;
begin
  // Le jeu commence , le joueur 1 joue en premier.
  GameState:=gsPlaying ;
  GameInfos.Playing:=Player1;

  GameComment('Joueur 1,  vous de commencer.');

  for Player:= Player1 to Player2 do
  begin
    // On donne les jetons aux joueurs:
    GameInfos.CoinsLeft[Player]:=NB_JETONS_PAR_JOUEUR;
  end;

  // On vide la table de jeu
    for Row:=FST_ROW to LST_ROW do
    begin
      for line:=FST_LINE to LST_LINE do
      begin
        GameInfos.CoinsPlayed[Row,Line]:= NO_PLAYER ;
      end;
    end;
  // Et on dessine
  RefreshDrawing();
end;


function TForm1.IsRowFull(Row: integer): boolean;
begin
  result:=not ((Row>=FST_ROW) and (Row<=LST_ROW) and
          (GameInfos.CoinsPlayed[Row,FST_LINE] = NO_PLAYER));
end;

// On met le jeton dans la colonne demande sur le jeu demand
// renvoi la ligne sur laquelle s'est mis le jeton ou -1 en cas d'erreur
function TForm1.PlayCoin(Player:integer;Row: integer;var CoinsPlayed: TCoinsPlayed):integer;
var line:integer;
begin

  result:=-1;
  line:= LST_LINE;
  while (line>=FST_LINE) and
        (CoinsPlayed[Row,Line] <> NO_PLAYER) do
  begin
    dec(Line);
  end;

  if Line>=FST_LINE then
  begin
    result:=Line;
    // Mmorisation du jeton dans la colonne
    CoinsPlayed[Row,Line]:=Player;
  end;

end;

(* Le joueur courant a jou dans la colonne "ROW" *)
procedure TForm1.PlayedInRow(ROW: integer);
var Line:integer;
begin

  // Insertion du pion dans la colonne.
  Line:=PlayCoin(GameInfos.Playing,Row,GameInfos.CoinsPlayed);
  If Line<FST_LINE then
    exit;

  // Jeton du joueur qui vient de jouer rang
  GameInfos.CoinPos[GameInfos.Playing]:= -1;

  // Il a un jeton de moins
  Dec(GameInfos.CoinsLeft[GameInfos.Playing]);

  // Vrifier si le joueur a gagn
  If PlayerHasWon(GameInfos.Playing,Row,Line,GameInfos.CoinsPlayed) then
  begin
    // Fin de la partie
    GameState:=gsFinished;
    GameComment('Partie gagne par le joueur '+inttostr(GameInfos.Playing+1)+'!');
    Inc(GameInfos.Victory[GameInfos.Playing]);
    Inc(GameInfos.nbGamesPlayed);
  end
  else
  begin
    // Joueur suivant
    GameInfos.Playing:=(GameInfos.Playing+1) mod 2;

    GameComment('Partie en cours, Joueur '+
                IntToStr(GameInfos.Playing+1)+
                ',  vous de jouer.');

    // Fin du jeu ?
    if GameInfos.CoinsLeft[Player1]+GameInfos.CoinsLeft[Player2]<=0 then
    begin
      // Fin de la partie
      GameInfos.Playing:=NO_PLAYER;
      GameState:=gsFinished;
      GameComment('Partie Termine par un match nul!');
      Inc(GameInfos.DrawGame);
      Inc(GameInfos.nbGamesPlayed);
    end;
  end;

  // Et on dessine
  RefreshDrawing();

end;

// La fonction ne teste que les nouvelles combinaisons joues
function TForm1.PlayerHasWon(Player:integer;Row,Line:integer;CoinsPlayed:TCoinsPlayed):boolean;
var Loc:integer;
begin
  (*
            ______________________________________
  FST_LINE |                                      |
           |                                      |
           |            Row,Line                  |
           |                                      |
  LST_LINE |--------------------------------------|
            FST_ROW                       LST_ROW.

  *)
  // init du rsultat
  result:=false;

  //Test: la colonne
  if (Line+3<=LST_LINE) and
     (CoinsPlayed[Row,Line+1]=Player) and
     (CoinsPlayed[Row,Line+2]=Player) and
     (CoinsPlayed[Row,Line+3]=Player) then
  begin
    result:=true;     // gagn sur la colonne
  end;

  //Test: la ligne
  for Loc:=max(Row-3,FST_ROW) to min(Row,LST_ROW-3) do
  begin
    if (CoinsPlayed[Loc,Line]=Player) and
       (CoinsPlayed[Loc+1,Line]=Player) and
       (CoinsPlayed[Loc+2,Line]=Player) and
       (CoinsPlayed[Loc+3,Line]=Player) then
    begin
      result:=true;     // gagn sur la ligne
    end;
  end;

  //Test: la diag descendante
  for Loc:=MaxIntvalue([-3,FST_ROW-Row,FST_LINE-Line]) to
           MinIntValue([0,LST_ROW-3-Row,LST_LINE-3-Line]) do
  begin
    if (CoinsPlayed[Loc+Row,Loc+Line]=Player) and
       (CoinsPlayed[Loc+Row+1,Loc+Line+1]=Player) and
       (CoinsPlayed[Loc+Row+2,Loc+Line+2]=Player) and
       (CoinsPlayed[Loc+Row+3,Loc+Line+3]=Player) then
    begin
      result:=true;     // gagn sur la diag descendante
    end;
  end;

  //Test: la diag montante
  for Loc:=MaxIntvalue([-3,FST_ROW-Row,Line-LST_LINE]) to
           MinIntValue([0,LST_ROW-3-Row,-3-FST_LINE+Line]) do
  begin
    if (CoinsPlayed[Loc+Row,Line-Loc]=Player) and
       (CoinsPlayed[Loc+Row+1,Line-Loc-1]=Player) and
       (CoinsPlayed[Loc+Row+2,Line-Loc-2]=Player) and
       (CoinsPlayed[Loc+Row+3,Line-Loc-3]=Player) then
    begin
      result:=true;     // gagn sur la diag montante
    end;
  end;

end;

(*
======================================
- Gestion du mode auto.             -
======================================
*)
procedure TForm1.ComputerPlays;
var CompLevel:integer;
var WhoIsPlaying,Row,RowDef:integer;
var Total,rnd:real;
var Rates:Array[FST_ROW..LST_ROW] of real;

  // Algorithme type MIN/MAX
  Function RecCompPlay(InitGame:TCoinsPlayed;Player,Row:integer;Lvl:integer):Real;
  var CoinsPlayed:TCoinsPlayed;
  var Line,LocRow:integer;
  var Maxi,Mini,Valf:real;
  begin
    result:=1.0; // note attribue au coup
    CoinsPlayed:=InitGame;
    // on teste le coup dans la colonne Row pour le joueur Player
    Line:= PlayCoin(Player,Row,CoinsPlayed);
    If Line<0 then
    begin
      result:=-1;  // La colonne est pleine
      exit;
    end
    else
    begin
      // coup gagnant?
      If PlayerHasWon(Player,Row,Line,CoinsPlayed) then
      begin
        // Oui : qui a gagn?
        if WhoIsPlaying=Player then
          result:=result*100  // Nous? alors c'est un bon coup
        else
          result:=result*0.01;  // L'autre! Argl il faut agir
        exit;
      end;
    end;
    (*
      TODO: On peut implmenter plein d'autres heuristiques ici
            pour amliorer le jeu de l'ordinateur, par exemple,
            compter les ouvertures et les opportunits
    *)
    if (Lvl<=0) then
      exit;

    // On reitere l'exploration sur un niveau
    Maxi:=0.01;
    Mini:=100;
    For LocRow:=FST_ROW to LST_ROW do
    begin
      // Exploration des colonnes pour les coups possibles du prochain joueur
      Valf:=RecCompPlay(CoinsPlayed,Player xor 1,LocRow,Lvl-1);
      if Valf>=0 then
      begin
        Maxi:=max(Maxi,Valf);
        Mini:=min(Mini,Valf);
      end;
    end;
    // Algo min/max
    if WhoIsPlaying=Player then
      result:=Mini
    else
      result:=Maxi;
  end;
begin

  if GameState<>gsPlaying then exit;
  GameState:=gsAutoPlaying;

  WhoIsPlaying := GameInfos.Playing;
  GameComment('Joueur '+IntToStr(WhoIsPlaying+1)+' en mode auto: .... je rflchis...');

  CompLevel:=GameObjects[WhoIsPlaying].RadioAuto.Tag;
  // Appel de l'algo rcursif MinMax
  Total:=0;
  RowDef:=0;
  For Row:=FST_ROW to LST_ROW do
  begin

    Rates[Row]:=RecCompPlay(GameInfos.CoinsPlayed,WhoIsPlaying ,Row,CompLevel);
    // Rate donne la note attribue au coup
    If Rates[Row]<0 then
    begin
      // Coup impossible
    end
    else
    begin
      // On mmorise chaque coup dans le tableau. Ceci permet de faire une
      // rponse Random avec une probabilit proporionnelle  la note reue.
      // Ca rend le jeu moins monotone... et puis tout le monde peut se tromper!
      //  Rate[Row]; contient la somme des notes de 0  Row.
      Total:=Total+Rates[Row];
      Rates[Row]:=Total;
      RowDef:=Row;
    end;
  end;

  random(round(time));
  // Choix de la rponse avec prfrence selon les notes
  rnd:=Random * Total ;
  Row:=FST_ROW;
  while (Row<=LST_ROW) and (rnd>Rates[Row]) do Inc(Row);

  If Row>LST_ROW then Row:=RowDef;
  // On joue dans la colonne Row  .
  GameState:=gsPlaying;
  PlayedInRow(Row);

end;

end.
